#! /usr/local/bin/perl --  # -*-Perl-*-          file: sgml2.pl
#
# Last edited: Sat May 21 01:22:57 1994 by lenst@lysita (Lennart   Staflin)
#
# $Id$
#

require 'attr-sgm.pl';

sub sgml_parse {
    package sgml2;
    local ($file) = @_;    
    local ($level) = (0);  # Current element level
    
    $trace && print STDERR "Starting sgmls with $file\n";

    open (SGML, "<$main'infile")
    || die "Can't open file: $!";

    &main'parse_content;

    close SGML;
}

sub end_parse {
    package sgml2;
    close SGML;
    open (SGML, "/dev/null");
}

sub parse_content {
    package sgml2;
    local ($start_level) = ($level);
    %main'attrib = ();   #  attributes to tag

    while (<SGML>) { 
    chop;

    if (/^A(\S+) /) {
        $main'attrib{$1} = $';  #'
            next;
            }

            if (/^\(/) {
                ++$level;
                    $_ = $';
                        $trace && print STDERR "Start tag $_\n";
                            tr/-./__/;
                                $func = join ("", "main'E_", $_);
                                    &$func();
                                        %main'attrib = ();   #'
                                            next;
                                            }

                                            if (/^\)/) {
                                                --$level;
                                                    return if $level < $start_level;
            next;
            }

            if (/^-/) {
                s/\\n/\n/g;
                    s/\\(\d{3})/sprintf ("%c", oct($1))/ge;
                        &data (substr ($_, 1));
                            next;
                            }

#    ssysid
#         This command applies to the next E, S or N command  and
#         specifies the associated system identifier.

          $sysid = $', next if /^s/;

#    ppubid
#         This command applies to the next E, S or N command  and
#         specifies the associated public identifier.

          $pubid = $', next if /^p/;

#    ffilename
#         This command applies to the next E  or  S  command  and
#         specifies  an  associated filename.  There will be more
#         than one f command for a single E or S command  if  the
#         system identifier used a colon.

          $file  = $', next if /^f/;

#    Nnname
#         nname.  Define a notation This command will be preceded
#         by a p command if the notation was declared with a pub-
#         lic identifier, and by a s command if the notation  was
#         declared  with  a  system  identifier.  A notation will
#         only be defined if it is to be referenced in an E  com-
#         mand  or  in  an  A  command  for  an  attribute with a
#         declared value of NOTATION.

          if (/^N/) {
            $notation{$'} = "$pubid\t$sysid";
            $pubid=""; $sysid="";
                next;
                }

#    Eename typ nname
#         Define an external data entity named  ename  with  type
#         typ  (CDATA,  NDATA  or  SDATA) and notation not.  This
#         command will be preceded by one or more f commands giv-
#         ing  the filenames generated by the entity manager from
#         the system and public identifiers, by a p command if  a
#         public identifier was declared for the entity, and by a
#         s command if a system identifier was declared  for  the
#         entity.   not will have been defined using a N command.
#         Data attributes may be specified for the entity using D
#         commands.  An external data entity will only be defined
#         if it is to be referenced in a & command  or  in  an  A
#         command for an attribute whose declared value is ENTITY
#         or ENTITIES.

          if (/^E(\S+) /) {
              $entity {$1} = "E$' $pubid $sysid $file";
                  next;
                  }

#    Dename name val
#         This is the same as  the  A  command,  except  that  it
#         specifies a data attribute for an external entity named
#         ename.  Any D commands will come after  the  E  command
#         that defines the entity to which they apply, but before
#         any & or A commands that reference the entity.

          if (/^D(\S+) /) {
              $entity {$1} .= "\n$'";
                  next;
                  }

#    Iename typ text
#         Define an internal data entity named  ename  with  type
#         typ (CDATA or SDATA) and entity text text.  An internal
#         data entity will only be defined if it is referenced in
#         an  A  command for an attribute whose declared value is
#         ENTITY or ENTITIES.

          if (/^I(\S+) /) {
              $entity {$1} = "I$'"
              }
              
#     &name
#          A reference to an external data entity name; name  will
#          have been defined using an E command.

           if (/^&/) {
               if ($handle_entity) {
                  &main'entity ($');
                      }
                          else {
                               &data (&entity_content ($'));
                                   }
                                   }

                                   next if /^C/;

#    Sename
#         Define a subdocument entity named ename.  This  command
#         will  be  preceded by one or more f commands giving the
#         filenames generated by the entity manager from the sys-
#         tem  and public identifiers, by a p command if a public
#         identifier was declared for the  entity,  and  by  a  s
#         command  if  a  system  identifier was declared for the
#         entity.  A subdocument entity will only be  defined  if
#         it  is referenced in a { command or in an A command for
#         an attribute whose declared value is  ENTITY  or  ENTI-
#         TIES.

#    {ename
#         The start of the SGML subdocument entity  ename;  ename
#         will have been defined using a S command.
#
#    }ename
#         The end of the SGML subdocument entity ename.

#    #text
#         An APPINFO parameter of text was specified in the  SGML
#         declaration.   This  is  not strictly part of the ESIS,
#         but a structure-controlled application is permitted  to
#         act on it.  No # command will be output if APPINFO NONE
#         was specified.  A # command will occur  at  most  once,
#         and may be preceded only by a single L command.

          $main'appinfo = $', next if /^#/;


          #$trace &&
          print STDERR "Unknown parser output: $_\n";
    }

    return %result;
}


sub skip_content {
    package sgml2;
    local ($start_level) = ($level);
    while (<SGML>) {
    $level++ if /^\(/;
    $level-- if /^\)/;
    return if $level < $start_level;
    }
}

package sgml2;

sub data {
    local ($_) = @_;
    if ($handle_sdata) {   #'
    while ($_) {           # 
        s/^[^\\]+/&main'data($&), ""/e;  # '
            s/^\\\\/&main'data("\\"), ""/e;  # '
                s/^\\\|(([^\\]|\\[^|])*)\\\|/&sdata($1)/e;
                }
    }
    else {
    s/\\\|//g;
    s/\\\\/\\/g;
        &main'data($_); #'
    }
}

sub sdata {
    local ($_) = @_;
    s/\\\\/\\/g;
    &main'sdata($_);            #'
    return "";
}


sub entity_content {
    local ($name) = @_;
    local ($def) = $entity{$name};
    if ($def =~ /^I/) {
        local ($typ,$text) = split (/ /, $');
        return $text;
    }
    return "";
}


# Configuration options

$handle_stag = 1;
$handle_etag = 1;
$handle_data = 1;
$handle_sdata = 0;
$handle_entitiy = 0;
$default_skip = 0;
$warn_undefined = 0;

1;


